package fr.username404.website.subpages

import kotlinx.browser.window
import org.w3c.dom.Document
import org.w3c.dom.HTMLElement
import org.w3c.dom.HTMLHeadElement
import org.w3c.dom.HTMLMetaElement

data class Subpage(
    val name: String,
    val head: Set<HTMLHeadElement>,
    val meta: Set<HTMLMetaElement>?,
    val content: HTMLElement
) {
    fun open(): Document = window.document.open(
        type = "text/html",
        replace = (head.map { it.outerHTML }.reduceOrNull { previous, current -> previous + '\n' + current } ?: "").plus(
            '\n' + content.outerHTML
        )
    )
}
